#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int mxN = 2e4+5;

int n;
pair<int, int> a[mxN];

int dp[mxN];

int solve()
{
    int Max = 0;
    for (int i = 1; i <= n; i++)
    {
        dp[i] = 1;
        for(int j=1;j<i;j++)
        {
            if(a[j].second<a[i].second)
            {
                dp[i] = max(dp[i], 1 + dp[j]);
            }
        }
        Max = max(Max, dp[i]);
    }

    return Max;
}

int main()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> a[i].first >> a[i].second;

    sort(a+1, a+n+1 , greater<pair<int,int>>());

    cout << solve();

    return 0;
}
