#include <iostream>
#include <set>
#include <iterator>
#include <vector>

using namespace std;
int main() {
    int n;
    cin >> n;
    set<pair<int, int> > s;
    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;
        s.insert(make_pair(a, b));
    }
    int a, b;
    for (set<pair<int, int> >::iterator it = s.begin(); it != s.end(); it++) {
        if (it != s.begin()) {
            if (it->first == a) {
                s.erase(make_pair(a, b));
            }
        }
        a = it->first;
        b = it->second;
    }
    vector<int> v;
    for (set<pair<int, int> >::iterator it = s.begin(); it != s.end(); it++) {
        v.push_back(it->second);
    }
    for (int i = 0; i < (v.size() + 1) / 2; ++i) {
        swap(v[i], v[v.size() - 1 - i]);
    }
    vector<int> dp(n + 1, 1e9);
    dp[0] = -1e9;
    for (int i = 0; i < v.size(); ++i) {
        int L = 0;
        int R = n - 1;
        while (R - L > 1) {
            int M = (R + L) / 2;
            if (v[i] > dp[M]) {
                L = M;
            } else {
                R = M;
            }
        }
        dp[R] = v[i];
    }
    int ans = 0;
    for (int i = 1; i < n; ++i) {
        if (dp[i] != 1e9) {
            ans++;
        }
    }
    cout << ans;
}