#include <bits/stdc++.h>

using namespace std;

const int vmax = 3e4;

int n;

pair<int,int> v[300005];

int dp[300005];

int aib[300005];

int ub(int x)
{
    return (x&(-x));
}

void update(int poz, int val)
{
    for(int i=poz;i<=vmax;i+=ub(i))
    {
        aib[i] = max(aib[i],val);
    }
}

int query(int poz)
{
    int rez = 0;
    for(int i=poz;i>=1;i-=ub(i))
    {
        rez = max(rez,aib[i]);
    }
    return rez;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin>>n;
    for(int i=1;i<=n;i++)
    {
        cin>>v[i].first>>v[i].second;
    }
    sort(v+1,v+n+1,greater<pair<int,int>>());
    int Max = 0;
    for(int i=1;i<=n;i++)
    {
        dp[i] = 1 + query(v[i].second-1);
        update(v[i].second,dp[i]);
        Max = max(Max,dp[i]);
    }
    cout<<Max<<'\n';
    return 0;
}
