#include <iostream>
#include <algorithm>

using namespace std;
#define lsb(x) (x&(-x))
namespace AIB {
  int aib[30001];
  int lim;
  void init(int n) {
    lim=n;
    for(int i=1; i<=n; i++)
      aib[i]=0;
  }
  void update(int poz, int val) {
    while(poz<lim) {
      aib[poz]=max(aib[poz],val);
      poz+=lsb(poz);
      //cout << poz << '\n';
    }
    return;
  }
  int query(int poz) {
    int sum=0;
    while(poz>0)
      sum=max(sum,aib[poz]),poz-=lsb(poz);
    return sum;
  }
};

int ind[20000];
int x[20000],y[20000];

int main() {
  int n;
  cin >> n;
  for(int i=0; i<n; i++) {
    cin >> x[i] >> y[i];
    ind[i]=i;
  }
  AIB::init(30000);
  sort(ind,ind+n,[](int a, int b){return x[a]<x[b] || (x[a]==x[b] && y[a]>y[b]);});
  for(int i=0; i<n; i++) {
    //cout << AIB::query(y[ind[i]]-1) <<' '<< x[ind[i]] <<' '<< y[ind[i]] <<'\n';
    AIB::update(y[ind[i]],AIB::query(y[ind[i]]-1)+1);
  }
  cout << AIB::query(30000) <<'\n';
}
