#include <iostream>
#include <algorithm>

using namespace std;
#define lsb(x) (x&(-x))
namespace AIB {
  int aib[30002];
  int lim;
  void init(int n) {
    lim=n;
    for(int i=1; i<=n; i++)
      aib[i]=0;
  }
  void update(int poz, int val) {
    while(poz>0) {
      aib[poz]=max(aib[poz],val);
      poz-=lsb(poz);
      //cout << poz << '\n';
    }
    return;
  }
  int query(int poz) {
    int sum=0;
    while(poz<=lim)
      sum=max(sum,aib[poz]),poz+=lsb(poz);
    return sum;
  }
};

int dp[20000];
int ind[20000];
int x[20000],y[20000];

int main() {
  int n;
  cin >> n;
  for(int i=0; i<n; i++) {
    cin >> x[i] >> y[i];
    ind[i]=i;
  }
  AIB::init(30001);
  sort(ind,ind+n,[](int a, int b){return x[a]<x[b] || (x[a]==x[b] && y[a]<y[b]);});
  //int maxx=1;
  //for(int i=0; i<n; i++) {
    //dp[i]=1;
    //for(int j=i-1; j>=0; j--) {
      //if(x[ind[i]]>x[ind[j]] && y[ind[i]]<y[ind[j]])
        //dp[i]=max(dp[i],dp[j]+1);
    //}
    //maxx=max(maxx,dp[i]);
  //}
  //cout << maxx << '\n';
  for(int i=0; i<n; i++) {
    //cout << AIB::query(y[ind[i]]+1) <<' '<< x[ind[i]] <<' '<< y[ind[i]] <<'\n';
    AIB::update(y[ind[i]],AIB::query(y[ind[i]]+1)+1);
  }
  cout << AIB::query(1) <<'\n';
}
