#include <iostream>
#include <algorithm>

#define MAX_N 20000

using namespace std;

struct rectangle {
    int w, h;
    bool operator < (const rectangle &a) const {
        if ( w == a.w )
            return h < a.h;
        return w < a.w;
    }
};

int maxR[MAX_N];
rectangle v[MAX_N];

int main() {
    int n, maxRectangle, i, j;

    cin >> n;
    for ( i = 0; i < n; i++ )
        cin >> v[i].w >> v[i].h;

    sort( v, v + n );

    maxRectangle = 0;
    for ( i = 0; i < n; i++ ) {
        maxR[i] = 1;
        for ( j = 0; j < i; j++ ) {
            if ( v[j].h > v[i].h )
                maxR[i] = max( maxR[i], maxR[j] + 1 );
        }
        maxRectangle = max( maxRectangle, maxR[i] );
    }

    cout << maxRectangle;

    return 0;
}
