#include <iostream>
#include <string>
#include <set>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;

typedef long long ll;
#define ff first
#define ss second

ll n, l, r, d;
vector<pair<int, int>>a;
set<pair<int, int>>s;
int dp[20007];

bool comp(pair<int, int>a, pair<int, int>b) {
	if (a.ff > b.ff) {
		return true;
	}
	if (a.ff < b.ff) {
		return false;
	}
	if (b.ss > a.ss) {
		return true;
	}
	return false;
}

int main()
{
	cin >> n;
	for (int i = 0; i < n; i++) {
		int x, y;
		cin >> x >> y;
		if (s.find({ x,y }) == s.end()) {
			a.push_back({ x,y });
		}
		s.insert({ x,y });
	}
	sort(a.begin(), a.end(), comp);
	int mx = 1;
	n = a.size();
	dp[0] = 1;
	for (int i = 1; i < n; i++) {
		dp[i] = 1;
		for (int j = 0; j < i; j++) {
			if (a[j].ff > a[i].ff && a[j].ss < a[i].ss) {
				dp[i] = max(dp[i], dp[j] + 1);
			}
		}
		mx = max(mx, dp[i]);
	}
	cout << mx << endl;
}