// -------------------- Includes -------------------- //
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <stdio.h>
#include <cstdlib>
#include <stdlib.h>
#include <array>
#include <string>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <list>
#include <iterator>
#include <numeric>
#include <complex>
#include <tuple>
#include <utility>
#include <cassert>
#include <assert.h>
#include <climits>
#include <limits.h>
#include <ctime>
#include <time.h>
#include <random>
#include <chrono>
#include <fstream>
using namespace std;

// -------------------- Typedefs -------------------- //

typedef long long ll;
typedef unsigned long long ull;
typedef double db;
typedef long double ld;

// -------------------- Defines -------------------- //

#define pr pair
#define mpr make_pair
#define ff first
#define ss second

#define mset multiset
#define mmap multimap
#define uset unordered_set
#define umap unordered_map
#define umset unordered_multiset
#define ummap unordered_multimap
#define pqueue priority_queue

#define sz(x) (int((x).size()))
#define len(x) (int((x).length()))
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define clr(x) (x).clear()

#define pf push_front
#define pb push_back
#define popf pop_front
#define popb pop_back
#define ft front
#define bk back

#define lb lower_bound
#define ub upper_bound
#define bs binary_search

// -------------------- Constants -------------------- //

const int MAX = int(1e9 + 5);
const ll MAXL = ll(1e18 + 5);
const ll MOD = ll(1e9 + 7);
const ll MOD2 = ll(998244353);

// -------------------- Functions -------------------- //

void fastio()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	return;
}

void precision(int x)
{
	cout.setf(ios::fixed | ios::showpoint);
	cout.precision(x);
	return;
}

ll gcd(ll a, ll b)
{
	if (a > b) {
		swap(a, b);
	}
	if (a == 0) {
		return b;
	}
	if (a == b) {
		return a;
	}
	return gcd(b % a, a);
}

ll lcm(ll a, ll b)
{
	return a / gcd(a, b) * b;
}

bool is_prime(ll a)
{
	if (a == 1) {
		return false;
	}
	ll i;
	for (i = 2; i * i <= a; i++) {
		if (a % i == 0) {
			return false;
		}
	}
	return true;
}

bool is_square(ll a)
{
	ll b = ll(sqrt(a));
	return (b * b == a);
}

bool is_cube(ll a)
{
	ll b = ll(cbrt(a));
	return (b * b * b == a);
}

int digit_sum(ll a)
{
	int sum = 0;
	while (a) {
		sum += int(a % 10);
		a /= 10;
	}
	return sum;
}

ll binpow(ll a, int b)
{
	ll ans = 1;
	while (b) {
		if ((b & 1) == 1) {
			ans *= a;
		}
		b >>= 1;
		a *= a;
	}
	return ans;
}

ll binpow_by_mod(ll a, ll b, ll mod)
{
	ll ans = 1;
	while (b) {
		if ((b & 1) == 1) {
			ans *= a;
			ans %= mod;
		}
		b >>= 1;
		a *= a;
		a %= mod;
	}
	return ans;
}

ll factorial(int a)
{
	int i;
	ll ans = 1;
	for (i = 2; i <= a; i++) {
		ans *= ll(i);
	}
	return ans;
}

ll factorial_by_mod(int a, ll mod)
{
	int i;
	ll ans = 1;
	for (i = 2; i <= a; i++) {
		ans *= ll(i);
		ans %= mod;
	}
	return ans;
}

// -------------------- Solution -------------------- //

const int N = 20005;
pr<int, int> a[N];
int n;

bool cond(const pr<int, int>& x, const pr<int, int>& y)
{
	return x.ff > y.ff;
}

vector<int> v;

mset<int> st;

vector<mset<int>> vv;

void solve()
{
	int i, j;
	cin >> n;
	for (i = 1; i <= n; i++) {
		cin >> a[i].ff >> a[i].ss;
	}
	sort(a + 1, a + n + 1, cond);
	/*for (i = 1; i <= n; i++) {
		cout << a[i].ff << ' ' << a[i].ss << endl;
	}*/
	int ind;
	clr(st);
	for (i = 1; i <= n; i++) {
		if (sz(st) == 0) {
			st.insert(a[i].ss);
			continue;
		}
		if (a[i].ff == a[i - 1].ff) {
			st.insert(a[i].ss);
		}
		else {
			vv.pb(st);
			clr(st);
			st.insert(a[i].ss);
		}
	}
	if (sz(st) != 0) {
		vv.pb(st);
	}
	/*for (i = 0; i < sz(vv); i++) {
		cout << i << '.' << endl;
		for (auto x : vv[i]) {
			cout << x << ' ';
		}
		cout << endl;
	}*/
	for (i = 0; i < sz(vv); i++) {
		/*cout << sz(v) << endl;
		for (j = 0; j < sz(v); j++) {
			cout << v[j] << ' ';
		}
		cout << endl;*/
		if (sz(v) == 0) {
			v.pb(*vv[i].begin());
			continue;
		}
		auto it = vv[i].ub(v.bk());
		if (it != vv[i].end()) {
			v.pb(*it);
		}
		else {
			bool fl = false;
			for (j = sz(v) - 2; j >= 0; j--) {
				auto itt = vv[i].ub(v[j]);
				if (itt != vv[i].end() && v[j + 1] > *itt) {
					v[j + 1] = *itt;
					fl = true;
					break;
				}
			}
			if (!fl) {
				if (v[0] > *vv[i].begin()) {
					v[0] = *vv[i].begin();
				}
			}
		}
	}
	cout << sz(v) << endl;
	/*for (i = 0; i < sz(v); i++) {
		cout << v[i] << ' ';
	}
	cout << endl;*/
	return;
}

void precalc()
{
	return;
}

int main()
{
	fastio();

	precalc();

	int tests = 1, tc;
	//cin >> tests;
	for (tc = 1; tc <= tests; tc++) {
		solve();
	}

	//cout << db(clock()) / CLOCKS_PER_SEC << endl;

	return 0;
}

/*
	# # # #   # # # #   # # # #   #       #    #       #     #
	   #      #         #     #    #     #    # #      #   #
	   #      # # # #   #     #     #   #    #   #     # #
	   #            #   #     #      # #    # # # #    #   #
	   #      # # # #   # # # #       #    #       #   #     #
*/