#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 20000 + 20;

struct Point
{
    int x, y;
    Point () {};
    Point (int _x, int _y)
    {
        x = _x;
        y = _y;
    }
    bool operator < (Point a)
    {
        return (a.x + a.y) < x + y;
//        if (a.x != x) return a.x < x;
//        return a.y < y;
    }
};

int n;
Point points[MAXN];

int t[MAXN];

bool cmp(Point a, Point b)
{
    if (a.x != b.x) return a.x > b.x;
    return a.y > b.y;
}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        int x, y;
        cin >> x >> y;
        points[i] = {x, y};
    }

    if (n < 25)
    {
        int answer = 0;
        sort(points + 1, points + n + 1, cmp);

        for (int i = 1; i <= n; i++)
        {
            int min_x = points[i].x;
            int min_y = points[i].y;
            int br = 1;

            for (int j = i + 1; j <= n; j++)
            {
                if (!(points[j].x <= min_x && points[j].y <= min_y))
                {
                    min_x = points[j].x;
                    min_y = points[j].y;
                    br++;
                }
            }
            answer = max(answer, br);
        }
        cout << answer << endl;
        return 0;
    }



//    for (int i = 1; i <= n; i++)
//    {
//        for (int j = 1; j <= n; j++)
//        {
//            if (i == j) continue;
//            if (points[i].x <= points[j].x && points[i].y <= points[j].y)
//            {
//                t[i]++;
//            }
//        }
//    }
//
//    for (int i = 1; i <= n; i++)
//    {
//        cerr << t[i] << " ";
//    }cerr << endl;

    int answer = 0;

    sort(points + 1, points + n + 1);

//    cerr << "-----------" << endl;
//    for (int i = 1; i <= n; i++)
//    {
//        cerr << points[i].x << " " << points[i].y << endl;
//    }


    for (int i = 1; i <= n; i++)
    {
        int min_x = points[i].x;
        int min_y = points[i].y;
        int br = 1;

        for (int j = i + 1; j <= n; j++)
        {
            int best = j;
            int best_min = 2e9;

            for (int k = j; k <= n; k++)
            {
                if (!(points[k].x <= min_x && points[k].y <= min_y))
                {
                    int tmp = (min_x - points[k].x) * (min_y - points[k].y);
                    if (tmp < best_min)
                    {
                        best_min = tmp;
                        best = k;
                    }
                }
            }

            if (!(points[best].x <= min_x && points[best].y <= min_y))
            {
                min_x = points[best].x;
                min_y = points[best].y;
                br++;
//                cerr << best << " ";
            }
            j = best;
        }
        answer = max(answer, br);
//        cerr << endl;
    }


    cout << answer << endl;

    return 0;
}
/**
7
1 3
4 3
5 1
5 1
3 4
9 4
1 1
------
3


In the set of the three rectangles: (4,3), (5,1) and (3,4),
no rectangle fits another.
*/
