#include <bits/extc++.h>
using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define sfor(i, l, r) for (int i = l; i <= r; ++i)
#define bfor(i, r, l) for (int i = r; i >= l; --i)
#define range(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int R = (1 << 15);
vi t(R * 2, 0);

void Set(int i, int x) {
    int v = R + i;
    if (t[R + i] >= x)
        return;
    t[v] = x;
    v >>= 1;
    while (v > 0) {
        t[v] = max(t[(v << 1)], t[(v << 1) + 1]);
        v >>= 1;
    }
}

int Get(int gl, int gr, int v = 1, int l = 0, int r = R) {
    if (gl >= r || l >= gr)
        return 0;
    if (gl <= l && r <= gr)
        return t[v];
    int m = ((l + r) >> 1);
    return max(Get(gl, gr, (v << 1), l, m), Get(gl, gr, (v << 1) + 1, m, r));
}

int main() {
    fast;
    int n;
    cin >> n;
    vector<pii> a(n);
    sfor(i, 0, n - 1) cin >> a[i].first >> a[i].second;
    sort(range(a));
    a.resize(unique(range(a)) - a.begin());
    n = a.size();
    vi dp(n, 1);
    int ans = 1;
    bfor(i, n - 1, 0) {
        dp[i] = Get(0, a[i].second) + 1;
        Set(a[i].second, dp[i]);
        ans = max(ans, dp[i]);
    }
    cout << ans << '\n';
}
