#include <bits/stdc++.h>

using namespace std;

struct Seg {
    int val = 0;
    int l,r,mid;
    Seg *ls, *rs;
    Seg(int l, int r): l(l), r(r), mid((l+r)/2) {
        if(l + 1 < r) {
            ls = new Seg(l,mid);
            rs = new Seg(mid,r);
        }
    }
    void update(int i, int v) {
        if(l + 1 == r) {
            val = max(val,v);
            return;
        }
        if(i < mid) {
            ls->update(i,v);
        } else {
            rs->update(i,v);
        }
        val = max(ls->val, rs->val);
    }
    int query(int a, int b) {
        if(a >= r || b <= l) { return 0; }
        if(a <= l && b >= r) { return val; }
        return max(ls->query(a,b),rs->query(a,b));
    }
};
const int my = 30001;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, x, y;
    Seg seg(0,my);
    cin >> n;
    vector<set<int>> recs(my);
    for(int i = 0; i < n ;i ++) {
        cin >> x >> y; x--;
        if(x == 0) {
            seg.update(y,1);
            continue;
        }
        // cout << "inserting " << x << " " << y << endl;
        recs[x].insert(y);
        // dp[x][y] = 1;
    }
    for(int xi = 1; xi < 10; xi ++) {
        // cout << "xi: " << xi << " | recs[xi].size(): " << (recs[xi].size()) << endl;
        for(auto it = recs[xi].begin(); it != recs[xi].end(); it ++) {
            // cout << "updating " << (*it) << " " << (1+seg.query((*it)+1,my)) << endl;
            seg.update(*it,1+seg.query((*it)+1,my));
        }
    }
    
    // for(int xi = 29998; xi >= 0; xi --) {
    //     dp[xi][0] = max(dp[xi][0], dp[xi+1][0]);
    //     for(int yi = 1; yi < my; yi ++) {
    //         dp[xi][yi] = max(dp[xi+1][yi],dp[xi+1][yi-1]+dp[xi][yi]);
    //     }
    // }
    cout << seg.query(0,my) << endl;
    return 0;
}