#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int mxN = 2e4+5;

int n;
pair<int, int> a[mxN];

int dp[2][30005];

int solve()
{
    for (int i = 1; i <= n; i++)
    {
        for (int j=1; j<=30000; ++j)
        {
            dp[i%2][j]=dp[(i+1)%2][j];
            if (a[i].second>=j)
            {
                dp[i%2][j]=max(dp[i%2][j],1+dp[(i+1)%2][a[i].second+1]);
            }
        }
    }

    return dp[n][1];
}

int main()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> a[i].first >> a[i].second;

    sort(a+1, a+n+1);

    cout << solve();

    return 0;
}
