#include <bits/stdc++.h>

using namespace std;

int tree[(int)4e5];

void add ( int v, int tl, int tr, int pos, int val )
{
    if ( tl == tr )
    {
        tree[v] = val;
        return;
    }

    int mid = ( tl + tr )/2;

    if ( pos <= mid )
        add( 2*v, tl, mid, pos, val );

    else
        add( 2*v+1, mid+1, tr, pos, val );

    tree[v] = max( tree[2*v], tree[2*v+1] );
}

int get_max ( int v, int tl, int tr, int l, int r )
{
    if ( l <= tl && tr <= r )
        return tree[v];

    if ( r < tl || tr < l )
        return -1e9;

    int mid = ( tl + tr ) / 2;

    return max( get_max( 2*v, tl, mid, l, r ), get_max( 2*v+1, mid+1, tr, l, r ) );
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    vector<pair<int,int>> a(n);

    for ( auto& [x,y] : a )
        cin >> x >> y;

    sort( a.begin(), a.end() );

    add( 1, 0, 4e4, a[0].second, 1 );

    for ( int i=1; i<n; i++ )
    if ( a[i] != a[i-1] )
        add( 1, 0, 4e4, a[i].second, get_max( 1, 0, 4e4, a[i].second+1, 4e4 )+1 );

    cout << get_max( 1, 0, 4e4, 0, 4e4 );

    return 0;
}
