#include <iostream>
#include <algorithm>


using namespace std;

const int NMAX = 2e4;

pair <int, int> a[NMAX];
int v[NMAX];
int longest[NMAX + 1];

int cb( int st, int dr, int val ) {
    int mij;
    while ( st < dr - 1 ) {
        mij = ( st + dr ) / 2;
        if ( v[mij] < val )
            st = mij;
        else
            dr = mij;
    }
    return st;
}
int main() {
    int n, i, maxim;
    cin >> n;
    for ( i = 0; i < n; i ++ ) {
        cin >> a[i].first >> a[i].second;
    }
    sort( a, a + n );
    for ( i = n - 1; i >= 0; i -- ) {
        v[n - i - 1] = a[i].second;
    }
    for ( i = 0; i < n; i ++ )
        longest[i] = 1e9;
    longest[1] = v[0];
    maxim = 1;
    for ( i = 1; i < n; i ++ ) {
        int aux = cb( 0, maxim + 1, v[i] );

        if ( aux == maxim && v[i] > v[maxim] ) {
            v[maxim + 1] = v[i];
            maxim = aux + 1;
        }
        longest[aux] = min( longest[aux], v[i] );
    }
    cout << maxim;
    return 0;
}
