#include <iostream>
#include "guess.h"

const long long MAX_A = (1e18);

using namespace std;

void guess() {
    int a;
    long long st, dr, p1, p2;

    st = 1;
    dr = MAX_A;
    while ( st <= dr ) {
        p1 = (st + dr) / 3;
        p2 = (st + dr) * 2 / 3;
        a = quest( p1 );
        b = quest( p2 );
        if ( a == 0 ) {
            res( p1 );
            return;
        }
        if ( b == 0 ) {
            res( p2 );
            return;
        }
        if ( b == 2 )
            st = p2 + 1;
        else if ( a == 2 ) {
            st = p1 + 1;
            dr = p2 - 1;
        } else
            dr = p1 - 1;
    }

    res( st );
}
