#include <bits/stdc++.h>

#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define pb push_back
#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define watch(x) cout << (#x) << " : " << x << '\n'

#define point pair<int, int>

using namespace std;

const int N = 2e4 + 128;

void test_case() {
    int n;
    cin >> n;
    vector <point> a(n);
    for (auto &x : a)
        cin >> x.first >> x.second;

    if (n > 64)
        return;

    int ans = -1;
    for (int mask = 0; mask < (1ll << n); mask++) {
        bitset <64> bs(mask);
        vector <point> cur;
        for (int i = 0; i < n; i++)
            if (bs[i])
                cur.pb(a[i]);
        sort(all(cur));
        bool bad = false;
        for (int i = 0; i < (int) cur.size(); i++) {
            if (bad) break;
            for (int j = i+1; j < (int) cur.size(); j++)
                if (!(cur[i].first > cur[j].first || cur[i].second > cur[j].second)) {
                    bad = true;
                    break;
                }
        }
        if (!bad) ans = max(ans, (int) cur.size());
    }
    cout << ans << '\n';
}

main () {
    boost;
    test_case();
    return 0;
}
