#include <iostream>
#include <vector>

#define int long long

using namespace std;

vector<bool> now;
int n, ans;
vector<int> x, y;

void check(){
    vector<int> a1, a2;
    for(int i = 0; i < n; i ++)
        if (now[i]){
            a1.push_back(x[i]);
            a2.push_back(y[i]);
        }
    int m = a1.size();
    bool good = 1;
    for(int i = 0; i < m; i ++){
        bool is = 0;
        for(int j = 0; j < m; j ++){
            if (i == j)
                continue;
            if ((a1[i] <= a1[j] && a2[i] <= a2[j]) || (a1[j] <= a1[i] && a2[j] <= a2[i]))
                is = 1;
        }
        if (is)
            good = 0;
    }
    if (good)
        ans = max(ans, m);
}

void bin(int step){
    if (step == n){
        check();
        return;
    }
    now[step] = false;
    bin(step + 1);
    now[step] = true;
    bin(step + 1);
}

main(){
    cin >> n;
    x.resize(n);
    y.resize(n);
    for(int i = 0; i < n; i ++){
        cin >> x[i] >> y[i];
    }

    now.resize(n);
    ans = 1;
    bin(0);

    cout << ans;
}
