#include <iostream>
#include <algorithm>
using namespace std;

const int MAXN = 20000;
pair<int, int> a[MAXN];
int dp[MAXN];

signed main() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) 
        cin >> a[i].first >> a[i].second;
    sort(a, a + n);
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        dp[i] = 1;
        for (int j = i - 1; j >= 0; --j) {
            if (a[j].second > a[i].second)
                dp[i] = max(dp[i], dp[j] + 1);
        }
        ans = max(ans, dp[i]);
    }
    cout << ans << endl;
}
