#include <iostream>
#include <algorithm>

using namespace std;

pair<int, int> pts[20005];
int cnt[20005];

int main() {
  int n;

  cin >> n;
  for ( int i = 1; i <= n; ++i ) {
    cin >> pts[i].first >> pts[i].second;
  }
  sort(pts + 1, pts + n + 1);
  cnt[1] = 1;
  for ( int i = 2; i <= n; ++i ) {
    cnt[i] = 1;
    for ( int j = 1; j < i; ++j ) {
      if ( pts[j].second > pts[i].second ) {
        cnt[i] = max(cnt[i], cnt[j] + 1);
      }
    }
  }
  int res = 0;
  for ( int i = 1; i <= n; ++i ) {
    res = max(res, cnt[i]);
  }
  cout << res;
  return 0;
}
