#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>

using namespace std;

typedef long long ll;

struct X
{
    int x;
    int y;

    bool operator< (const X& c) const
    {
        if (x == c.x)
            return y > c.y;
        return x < c.x;
    }

    bool operator== (const X& c) const
    {
        return x == c.x && y == c.y;
    }
};

int main()
{
    int n;
    cin >> n;
    vector<X> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i].x >> a[i].y;
    sort(a.begin(), a.end());
    vector<int> dp(n + 1);
    dp[0] = 0;
    int maxx = 0;
    for (int i = 1; i <= n; ++i)
    {
        dp[i] = 1;
        for (int j = 0; j < i; ++j)
        {
            if (a[j].y > a[i - 1].y)
            {
                dp[i] = max(dp[i], dp[j + 1] + 1);
            }
        }
        maxx = max(maxx, dp[i]);
    }
    cout << maxx << '\n';
    return 0;
}
