//#define _GLIBCXX_DEBUG

#define AIDAR ASADULLIN

#include <bits/stdc++.h>

using namespace std;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
#define ll long long
#define trace(x) cout << #x << " = " << (x) << endl;
#define all(x) x.begin(), (x).end()
#define rall(x) x.rbegin(), (x).rend()
#define unique(x) x.erase(unique(all(x)), (x).end())
#define ld long double
#define sz(s) (int) size(s)

const int N = 200001;
const ll infL = 1e18;
const int infI = 1e9 + 7;
const ll mod = 1e9 + 7;


vector<int> t;
int sz = 1;
void init(int n) {
    sz = n;
    t.resize(n);
}

void add(int i, int v) {
    while (i < sz) {
        t[i] = max(t[i], v);
        i = i | (i + 1);
    }
}

int get(int r) {
    int ans = 0;
    while (r > -1) {
        ans = max(ans, t[r]);
        r = r & (r + 1);
        --r;
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i].first >> v[i].second;
    }
    sort(all(v));
    init(30001);
    for (int i = 0; i < n; ++i) {
        add(v[i].second, get(v[i].second - 1) + 1);
    }
    cout << get(30000);
    return 0;
}