#include <vector>
#include <iostream>
#include <algorithm>

int finder(std::vector<int> findIn, int loc)
{
	int max = 0;
	for (int i = loc; i >= 0; i--)
		if (findIn[i] > findIn[loc])
			max = std::max(max, finder(findIn, i));
	return max + 1;
}

int main()
{
	int n;
	std::cin >> n;
	std::vector<std::pair<int, int>> rectangles(n);
	for (int i = 0; i < n; i++)
		std::cin >> rectangles[i].first >> rectangles[i].second;

	std::sort(rectangles.begin(), rectangles.end(), 
		[](std::pair<int, int> a, std::pair<int, int> b) { 
			if (a.first == b.first)
				return a.second < b.second;
			return a.first < b.first; 
		});

	std::vector<int> temp(rectangles.size());

	for (int i = 0; i < rectangles.size(); i++)
		temp[i] = rectangles[i].second;

	int max = 0;
	for (int i = temp.size()-1; i >= 0; i--)
		max = std::max(max, finder(temp, i));

	std::cout << max;

	return 0;
}