#define _CRT_SECURE_NO_WARNINGS

/*--------------Define--------------*/
#define MOD 1000000007
#define INF 1000000000
#define cn const
#define pb push_back
#define ppb pop_back
#define ff first
#define ss second
#define sz size()
#define all(x) x.begin(), x.end()
#define sortall(x) sort(all(x))


/*--------------Include--------------*/
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <string>
#include <fstream>
#include <ostream>
#include <deque>
#include <iomanip>
#include <map>
#include <set>
#include <stack>
#include <cstdlib>

#define endl '\n'


using namespace std;


using ll = long long;
using ull = unsigned long long;
using pll = pair<long long, long long>;
using vl = vector<long long>;
using vpll = vector<pair<long long, long long>>;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using vs = vector<string>;
using vpii = vector<pii>;


template<typename T>
constexpr T sqr(const T& x)
{
    return x * x;
}

template<typename T>
bool rMin(T& v, const T& rval)
{
    if (rval < v) {
        v = rval;
        return true;
    }
    return false;
}

template<typename T>
bool rMax(T& v, const T& rval)
{
    if (v < rval) {
        v = rval;
        return true;
    }
    return false;
}


int dp[20002];

void solve()
{
    int n;

    cin >> n;

    vpii a(n);

    for (int i = 0; i < n; i++)
    {
        cin >> a[i].ff >> a[i].ss;
    }

    sortall(a);

    vi b;

    for (int i = 0; i < n; i++)
    {
        b.pb(a[i].ss);
    }

    reverse(all(b));

    fill(dp, dp + 20002, 1);

    for (int i = 0; i < n; i++)
    {
        for (int j = i - 1; j >= 0; j--)
        {
            if (b[j] < b[i])
            {
                rMax(dp[i], dp[j] + 1);
            }
        }
    }

    int res = 0;

    for (int i = 0; i < n; i++)
    {
        rMax(res, dp[i]);
    }

    cout << res << endl;
}



int main()
{
#ifdef _DEBUG
    freopen("Input.txt", "r", stdin);
#endif // _DEBUG


    ios::sync_with_stdio(false);
    cin.tie(0);


    int t = 1;
    //cin >> t;

    while (t--)
    {
        solve();
    }



#ifdef _DEBUG
    cin.get();
#endif // _DEBUG

    return 0;
}