#define _CRT_SECURE_NO_WARNINGS

/*--------------Define--------------*/
#define MOD 1000000007
#define INF 1000000000
#define cn const
#define pb push_back
#define ppb pop_back
#define ff first
#define ss second
#define sz size()
#define all(x) x.begin(), x.end()
#define sortall(x) sort(all(x))


/*--------------Include--------------*/
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <string>
#include <fstream>
#include <ostream>
#include <deque>
#include <iomanip>
#include <map>
#include <set>
#include <stack>
#include <cstdlib>

#define endl '\n'


using namespace std;


using ll = long long;
using ull = unsigned long long;
using pll = pair<long long, long long>;
using vl = vector<long long>;
using vpll = vector<pair<long long, long long>>;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using vs = vector<string>;
using vpii = vector<pii>;


template<typename T>
constexpr T sqr(const T& x)
{
    return x * x;
}

template<typename T>
bool rMin(T& v, const T& rval)
{
    if (rval < v) {
        v = rval;
        return true;
    }
    return false;
}

template<typename T>
bool rMax(T& v, const T& rval)
{
    if (v < rval) {
        v = rval;
        return true;
    }
    return false;
}


#ifdef _DEBUG
ll n;
void res(ll x)
{
    cout << "Res: " << x << endl;
}

int quest(ll x)
{
    if (n == x)
    {
        return 0;
    }
    if (x < n)
    {
        return 1;
    }

    return 2;
}
#endif


void guess()
{
    ll l = 0;
    ll r = 1e18;

    while (r - l > 1)
    {
        ll mid = (l + r) / 2;

        int x = quest(mid);

        if (x == 0)
        {
            res(mid);
            return;
        }
        
        if (x == 1)
        {
            l = mid;
        }
        else
        {
            r = mid;
        }
    }

    res(r);
}



#ifdef _DEBUG
int main()
{
#ifdef _DEBUG
    //freopen("Input.txt", "r", stdin);
    cin >> n;
#endif // _DEBUG


    ios::sync_with_stdio(false);
    cin.tie(0);


    int t = 1;
    //cin >> t;

    while (t--)
    {
        guess();
        //solve();
    }



#ifdef _DEBUG
    cin.get();
#endif // _DEBUG

    return 0;
}
#endif