#include <bits/stdc++.h>
using namespace std;
const int maxn = 20010;
struct point
{
    int x, y;
} p[maxn];
int n, dp[maxn], tree[4 * maxn];
bool cmp(point p1, point p2)
{
    if (p1.y > p2.y)
        return true;
    if (p1.y < p2.y)
        return false;
    return p1.x > p2.x;
}

void update(int root, int left, int right, int idx, int val)
{
    if (left == right)
    {
        tree[root] = val;
        return;
    }

    int mid = (left + right) / 2;
    if (idx <= mid)
        update(root * 2, left, mid, idx, val);
    else
        update(root * 2 + 1, mid + 1, right, idx, val);

    tree[root] = max(tree[root * 2], tree[root * 2 + 1]);
}

int query(int root, int left, int right, int qleft, int qright)
{
    if (left > qright || right < qleft)
        return 0;

    if (left >= qleft && right <= qright)
        return tree[root];

    int mid = (left + right) / 2;
    return max(query(root * 2, left, mid, qleft, qright),
               query(root * 2 + 1, mid + 1, right, qleft, qright));
}
void solve()
{
    cin >> n;
    for (int i = 1; i <= n; i ++)
        cin >> p[i].x >> p[i].y;
    sort(p + 1, p + n + 1, cmp);
    int ans = 0;
    for (int i = 1; i <= n; i ++)
    {

        dp[i] = query(1, 0, 30000, 0, p[i].x - 1) + 1;
        update(1, 0, 30000, p[i].x, dp[i]);
        if (dp[i] > ans)
            ans = dp[i];
    }
    cout << ans << endl;
}
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int main()
{
    ///speed();
    solve();
    return 0;
}
